package cn.citycraft.RealBackpacks;

import java.lang.reflect.Constructor;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import net.milkbowl.vault.economy.Economy;

import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.ShapedRecipe;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.material.MaterialData;
import org.bukkit.plugin.RegisteredServiceProvider;
import org.bukkit.plugin.java.JavaPlugin;

import cn.citycraft.RealBackpacks.config.Config;
import cn.citycraft.RealBackpacks.listeners.CraftListener;
import cn.citycraft.RealBackpacks.listeners.EntityListener;
import cn.citycraft.RealBackpacks.listeners.InventoryListener;
import cn.citycraft.RealBackpacks.listeners.PlayerListener;
import cn.citycraft.RealBackpacks.util.MysqlFunctions;
import cn.citycraft.RealBackpacks.util.RBUtil;
import cn.citycraft.RealBackpacks.util.VersionChecker;

public class RealBackpacks extends JavaPlugin {

	public static RBInterface NMS;

	public static Economy econ = null;
	public static boolean globalGlow = true;

	private static boolean average = false;
	private static boolean add = false;
	public static VersionChecker versionChecker;
	private boolean usingMysql = false;
	private boolean vault = true;
	private boolean usingPermissions = true;
	private String user = null;
	private String password = null;

	private String url;
	public List<String> backpacks = new ArrayList<String>();
	public HashMap<String, List<String>> backpackData = new HashMap<String, List<String>>();
	public HashMap<String, List<String>> backpackLore = new HashMap<String, List<String>>();
	public HashMap<String, List<String>> backpackRecipe = new HashMap<String, List<String>>();
	public HashMap<String, ItemStack> backpackItems = new HashMap<String, ItemStack>();
	public HashMap<String, ItemStack> backpackOverrides = new HashMap<String, ItemStack>();
	public HashMap<String, List<String>> backpackBlacklist = new HashMap<String, List<String>>();

	public HashMap<String, List<String>> backpackWhitelist = new HashMap<String, List<String>>();
	public HashMap<String, String> playerData = new HashMap<String, String>();
	public HashMap<String, String> adminFullView = new HashMap<String, String>();
	public List<String> adminRestrictedView = new ArrayList<String>();

	public List<String> slowedPlayers = new ArrayList<String>();

	// List key
	// 0 = Size
	// 1 = UseRecipe
	// 2 = id
	// 3 = name
	// 4 =destroyContents
	// 5 = dropContents
	// 6 = dropBackpack
	// 7 = keepBackpack
	// 8 = walkSpeedEnabled
	// 9 = walkSpeedMultiplier
	// 10 = increasedHungerEnabled
	// 11 = hungerBarsToDeplete
	// 12 = hungerBarsToSubtractWhenEating
	// 13 = Purchasable
	// 14 = Price
	// 15 = OpenWith
	// 16 = UseWhitelist
	// 17 = addGlow
	// 18 = Unstackable

	@Override
	public FileConfiguration getConfig() {
		if (Config.getInstance() == null) {
			Config.load(this);
		}
		return Config.getInstance();
	}

	private ItemStack getConfigLore(final ItemStack item, final String backpack) {
		final List<String> key = backpackData.get(backpack);
		final ItemMeta meta = item.getItemMeta();
		final ArrayList<String> lore = new ArrayList<String>();
		lore.clear();
		if (backpackLore.get(backpack) != null) {
			for (final String s : backpackLore.get(backpack)) {
				lore.add(ChatColor.translateAlternateColorCodes('&', s));
			}
			meta.setLore(lore);
		}
		meta.setDisplayName(ChatColor.translateAlternateColorCodes('&', key.get(3)));
		item.setItemMeta(meta);
		return item;
	}

	public String getPass() {
		return password;
	}

	public String getUrl() {
		return url;
	}

	public String getUser() {
		return user;
	}

	public boolean isAdding() {
		return add;
	}

	public boolean isAveraging() {
		return average;
	}

	public boolean isUsingMysql() {
		return usingMysql;
	}

	public boolean isUsingPerms() {
		return usingPermissions;
	}

	public boolean isUsingVault() {
		return vault;
	}

	@Override
	public void onEnable() {
		final String p = getServer().getClass().getPackage().getName();
		final String version = p.substring(p.lastIndexOf('.') + 1);
		String classname = getClass().getPackage().getName() + ".versions." + version;
		try {
			final Class<?> clazz = Class.forName(classname);
			final Constructor<?> cons = clazz.getDeclaredConstructor(getClass());
			final Object obj = cons.newInstance(this);
			if (obj instanceof RBInterface) {
				NMS = (RBInterface) obj;
			}
		} catch (final Exception e) {
			globalGlow = false;
		}

		if (isEnabled()) {
			MysqlFunctions.setMysqlFunc(this);
			RBUtil.setRBUtil(this);
			if (!setupEconomy()) {
				getLogger().warning("Vault 未找到, 部分功能无法使用...");
				vault = false;
			} else {
				getLogger().info("Vault 已找到, 启用经济系统...");
			}
			setupLists();
			setup();
			if (isEnabled()) {
				getServer().getPluginManager().registerEvents(new PlayerListener(this), this);
				getServer().getPluginManager().registerEvents(new CraftListener(this), this);
				getServer().getPluginManager().registerEvents(new InventoryListener(this), this);
				getServer().getPluginManager().registerEvents(new EntityListener(this), this);
				getServer().getScheduler().runTaskTimer(this, new WalkSpeedRunnable(this), 20, 20);

				getCommand("rb").setExecutor(new MainCommand(this));

				getLogger().info("真实背包已加载 By: 喵♂呜.");
			}
		}
		new VersionChecker(this);
	}

	@Override
	public void reloadConfig() {
		Config.load(this);
	}

	@Override
	public void saveConfig() {
		if (Config.getInstance() == null) {
			Config.load(this);
		}
		Config.save();
	}

	@SuppressWarnings("deprecation")
	public void setup() {
		user = getConfig().getString("Data.MySQL.username");
		password = getConfig().getString("Data.MySQL.password");
		url = "jdbc:mysql://" + getConfig().getString("Data.MySQL.ip") + ":" + getConfig().getInt("Data.MySQL.port") + "/"
				+ getConfig().getString("Data.MySQL.database");

		if (!getConfig().isSet("Config.MultipleBackpacksInInventory.average")) {
			average = false;
		} else {
			average = getConfig().getBoolean("Config.MultipleBackpacksInInventory.average");
		}

		if (!getConfig().isSet("Config.MultipleBackpacksInInventory.add")) {
			add = false;
		} else {
			add = getConfig().getBoolean("Config.MultipleBackpacksInInventory.add");
		}

		if (!getConfig().isSet("Data.FileSystem")) {
			usingMysql = false;
		} else if (getConfig().getString("Data.FileSystem").equalsIgnoreCase("mysql")
				|| getConfig().getString("Data.FileSystem").equalsIgnoreCase("sql")) {
			usingMysql = true;
			if (!MysqlFunctions.checkIfTableExists("rb_data")) {
				MysqlFunctions.createTables();
			}
		} else {
			usingMysql = false;
		}

		if (!getConfig().isSet("Config.usePermissions")) {
			usingPermissions = true;
		} else {
			usingPermissions = getConfig().getBoolean("Config.usePermissions");
		}

		for (final String backpack : backpacks) {

			final String override = getConfig().getString("Backpacks." + backpack + ".Override");
			if (override != null) {
				backpackOverrides.put(backpack, RBUtil.getItemstackFromString(override));
			} else {
				backpackOverrides.put(backpack, null);
			}

			final List<String> key = backpackData.get(backpack);
			final String backpackItem = key.get(2);
			backpackItems.put(backpack, getConfigLore(RBUtil.getItemstackFromString(backpackItem), backpack));

			ShapedRecipe recipe = null;
			if (key.get(1).equalsIgnoreCase("true")) {
				recipe = new ShapedRecipe(backpackItems.get(backpack));
				recipe.shape("abc", "def", "ghi");
				int i = 0;
				for (final String s : backpackRecipe.get(backpack)) {
					final String[] itemIds = s.split(",");
					char shapechar = 0;
					for (final String itemid : itemIds) {
						i++;
						switch (i) {
						case 1:
							shapechar = 'a';
							break;
						case 2:
							shapechar = 'b';
							break;
						case 3:
							shapechar = 'c';
							break;
						case 4:
							shapechar = 'd';
							break;
						case 5:
							shapechar = 'e';
							break;
						case 6:
							shapechar = 'f';
							break;
						case 7:
							shapechar = 'g';
							break;
						case 8:
							shapechar = 'h';
							break;
						case 9:
							shapechar = 'i';
							break;
						}
						final String[] itemsplit = itemid.split(":");
						if (itemsplit[0].equals("0")) {
							continue;
						}
						if (itemsplit.length > 1) {
							final Material baseblock = Material.getMaterial(Integer.parseInt(itemsplit[0]));
							final MaterialData ingredient = new MaterialData(baseblock, (byte) Integer.parseInt(itemsplit[1]));
							recipe.setIngredient(shapechar, ingredient);
						} else {
							final Material baseblock = Material.getMaterial(Integer.parseInt(itemsplit[0]));
							recipe.setIngredient(shapechar, baseblock);
						}
					}
				}
				getServer().addRecipe(recipe);
			}
		}
	}

	private boolean setupEconomy() {
		if (getServer().getPluginManager().getPlugin("Vault") == null)
			return false;
		final RegisteredServiceProvider<Economy> rsp = getServer().getServicesManager().getRegistration(Economy.class);
		if (rsp == null)
			return false;
		econ = rsp.getProvider();
		return econ != null;
	}

	public void setupLists() {
		backpacks.clear();
		backpackRecipe.clear();
		backpackData.clear();
		backpackLore.clear();
		for (final String backpack : getConfig().getConfigurationSection("Backpacks").getKeys(false)) {
			final List<String> list = new ArrayList<String>();
			backpacks.add(backpack);
			list.add(0, getConfig().getString("Backpacks." + backpack + ".Size"));
			list.add(1, getConfig().getString("Backpacks." + backpack + ".UseRecipe"));
			if (getConfig().getStringList("Backpacks." + backpack + ".Recipe") != null) {
				backpackRecipe.put(backpack, getConfig().getStringList("Backpacks." + backpack + ".Recipe"));
			} else {
				backpackRecipe.put(backpack, null);
			}
			list.add(2, getConfig().getString("Backpacks." + backpack + ".BackpackItem.id"));
			list.add(3, getConfig().getString("Backpacks." + backpack + ".BackpackItem.name"));
			if (getConfig().getStringList("Backpacks." + backpack + ".BackpackItem.lore") != null) {
				backpackLore.put(backpack, getConfig().getStringList("Backpacks." + backpack + ".BackpackItem.lore"));
			} else {
				backpackLore.put(backpack, null);
			}
			list.add(4, getConfig().getString("Backpacks." + backpack + ".onDeath.destroyContents"));
			list.add(5, getConfig().getString("Backpacks." + backpack + ".onDeath.dropContents"));
			list.add(6, getConfig().getString("Backpacks." + backpack + ".onDeath.dropBackpack"));
			list.add(7, getConfig().getString("Backpacks." + backpack + ".onDeath.keepBackpack"));
			list.add(8, getConfig().getString("Backpacks." + backpack + ".WalkSpeedFeature.enabled"));
			list.add(9, getConfig().getString("Backpacks." + backpack + ".WalkSpeedFeature.walkingSpeed"));
			list.add(10, getConfig().getString("Backpacks." + backpack + ".IncreasedHungerFeature.enabled"));
			list.add(11, getConfig().getString("Backpacks." + backpack + ".IncreasedHungerFeature.extraHungerBarsToDeplete"));
			list.add(12, getConfig().getString("Backpacks." + backpack + ".IncreasedHungerFeature.hungerBarsToSubtractWhenEating"));
			list.add(13, getConfig().getString("Backpacks." + backpack + ".Purchasable"));
			list.add(14, getConfig().getString("Backpacks." + backpack + ".Price"));
			list.add(15, getConfig().getString("Backpacks." + backpack + ".OpenWith"));
			list.add(16, getConfig().getString("Backpacks." + backpack + ".UseWhitelist"));
			list.add(17, getConfig().getString("Backpacks." + backpack + ".addGlow"));
			list.add(18, getConfig().getString("Backpacks." + backpack + ".Unstackable"));
			backpackData.put(backpack, list);
			backpackBlacklist.put(backpack, getConfig().getStringList("Backpacks." + backpack + ".ItemBlacklist"));
			backpackWhitelist.put(backpack, getConfig().getStringList("Backpacks." + backpack + ".ItemWhitelist"));
		}
	}

}
