package cn.citycraft.RealBackpacks.util;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.bukkit.Material;
import org.bukkit.inventory.ItemStack;

import cn.citycraft.RealBackpacks.RealBackpacks;
import cn.citycraft.RealBackpacks.config.PlayerConfig;

public class RBUtil {

	private static RealBackpacks plugin;

	public static void destroyContents(final String name, final String backpack) {
		plugin.getServer().getScheduler().runTaskAsynchronously(plugin, new Runnable() {
			@Override
			public void run() {
				if (plugin.isUsingMysql()) {
					MysqlFunctions.delete(name, backpack);
				} else {
					PlayerConfig.getInstance(plugin, name).set(backpack + ".Inventory", null);
					PlayerConfig.save();
				}
			}
		});
	}

	public static int getFoodLevel(final int foodlevel, final int pLevel, final int listsize, final int key, final List<String> backpackList) {
		int i = 0;
		if (plugin.isAveraging()) {
			int average = 0;
			for (final String backpack : backpackList) {
				average += Integer.parseInt(plugin.backpackData.get(backpack).get(key));
			}
			i = foodlevel - (average / listsize);
		} else if (plugin.isAdding()) {
			int sum = 0;
			for (final String backpack : backpackList) {
				sum += Integer.parseInt(plugin.backpackData.get(backpack).get(key));
			}
			i = foodlevel - sum;
		} else {
			final List<Integer> list = new ArrayList<Integer>();
			for (final String backpack : backpackList) {
				list.add(Integer.parseInt(plugin.backpackData.get(backpack).get(key)));
			}
			i = foodlevel - Collections.max(list);
		}
		return i;
	}

	@SuppressWarnings("deprecation")
	public static ItemStack getItemstackFromString(final String s) {
		ItemStack item = null;
		final String[] split = s.split(":");
		if (split.length == 1) {
			item = new ItemStack(Material.getMaterial(Integer.parseInt(split[0])), 1);
		} else {
			if (split[1].equalsIgnoreCase("enchant") || split[1].equalsIgnoreCase("lore")
					|| split[1].equalsIgnoreCase("all")) {
				item = new ItemStack(Material.getMaterial(Integer.parseInt(split[0])));
			} else {
				item = new ItemStack(Material.getMaterial(Integer.parseInt(split[0])), 1,
						(byte) Integer.parseInt(split[1]));
			}
		}
		return item;
	}

	public static boolean hasLore(final ItemStack item) {
		if (item.getItemMeta() != null) {
			if (item.getItemMeta().hasDisplayName() || item.getItemMeta().hasLore())
				return true;
		}
		return false;
	}

	public static boolean isEnchanted(final String s) {
		final String[] split = s.split(":");
		int i = 0;
		if (split.length != 1) {
			for (i = 1; i < split.length; i++) {
				if (split[i].equalsIgnoreCase("enchant") || split[i].equalsIgnoreCase("all"))
					return true;
			}
		}
		return false;
	}

	public static boolean isLored(final String s) {
		final String[] split = s.split(":");
		int i = 0;
		if (split.length != 1) {
			for (i = 1; i < split.length; i++) {
				if (split[i].equalsIgnoreCase("lore") || split[i].equalsIgnoreCase("all"))
					return true;
			}
		}
		return false;
	}

	public static boolean itemsAreEqual(final ItemStack item, final String s) {
		final boolean lore = hasLore(item);
		final boolean enchant = item.getEnchantments().size() >= 1;
		final boolean isLored = isLored(s);
		final boolean isEnchanted = isEnchanted(s);
		if (!isLored && !isEnchanted && item.isSimilar(getItemstackFromString(s)))
			return true;
		else if (item.getType() == getItemstackFromString(s).getType()) {
			if (enchant && !lore)
				return isEnchanted && !isLored;
			else if (enchant && lore)
				return isEnchanted && isLored;
			else if (!enchant && lore)
				return isLored && !isEnchanted;
		}
		return false;
	}

	public static void setRBUtil(final RealBackpacks plugin) {
		RBUtil.plugin = plugin;
	}

	public static String stringToBackpack(String s) {
		for (final String b : plugin.backpacks) {
			if (b.equalsIgnoreCase(s))
				return b;
		}
		return null;
	}

}
